Package: opGMMassessment
Type: Package
Title: Optimized Automated Gaussian Mixture Assessment
Version: 0.4.1
Authors@R: c(
    person(given = "Jorn",
           family = "Lotsch",
           role = c("aut", "cre"),
           email = "j.lotsch@em.uni-frankfurt.de",
           comment = c(ORCID = "0000-0002-5818-6958")),
    person(given = "Sebastian",
           family = "Malkusch",
           role = c("aut"),
           email = "",
           comment = c(ORCID = "0000-0001-6766-140X")))
Maintainer: Jorn Lotsch <j.lotsch@em.uni-frankfurt.de>
Description: Necessary functions for optimized automated evaluation of the number and parameters of Gaussian mixtures in one-dimensional data. Various methods are available for parameter estimation and for determining the number of modes in the mixture. A detailed description of the methods ca ben found in Lotsch, J., Malkusch, S. and A. Ultsch. (2022) <doi:10.1016/j.imu.2022.101113>.
URL: https://github.com/JornLotsch/opGMMassessment
Depends: R (>= 3.5.0)
License: GPL-3
Encoding: UTF-8
LazyData: true
Imports: AdaptGauss, DataVisualizations, DistributionOptimization,
        cluster, mixtools, grDevices, methods, foreach, stats, utils,
        rlang, ggplot2, parallel, caTools, dplyr, mclust, mixAK,
        multimode, NbClust, ClusterR, doParallel
NeedsCompilation: no
Packaged: 2026-04-16 17:59:34 UTC; joern
Author: Jorn Lotsch [aut, cre] (ORCID: <https://orcid.org/0000-0002-5818-6958>),
  Sebastian Malkusch [aut] (ORCID:
    <https://orcid.org/0000-0001-6766-140X>)
Repository: CRAN
Date/Publication: 2026-04-17 05:10:57 UTC

# A parallel version of cluster::clusGap, modified from the R package 'cluster'
# Maechler, M., Rousseeuw, P., Struyf, A., Hubert, M., Hornik, K.(2021).
# cluster: Cluster Analysis Basics and Extensions. R package version 2.1.2.
#' @importFrom stats dist runif var
#' @importFrom parallel detectCores mclapply
#' @importFrom cluster maxSE
clusGapP <- function(x, FUNcluster, K.max, B = 100, d.power = 1, spaceH0 = c("scaledPCA", "original"), nProc, ...) {
  # Check input parameters
  stopifnot(is.function(FUNcluster), length(dim(x)) == 2, K.max >= 2, (n <- nrow(x)) >= 1, ncol(x) >= 1)
  if (B != (B. <- as.integer(B)) || (B <- B.) <= 0) {
    stop("'B' has to be a positive integer")
  }

  # Get the call
  cl. <- match.call()

  # Convert x to matrix if it's a data frame
  if (is.data.frame(x)) {
    x <- as.matrix(x)
  }

  # Create a sequence of row indices
  ii <- seq_len(n)

  # Define the W.k function
  W.k <- function(X, kk) {
    clus <- if (kk > 1) {
      FUNcluster(X, kk)$cluster
    } else {
      rep.int(1L, nrow(X))
    }
    0.5 * sum(vapply(split(ii, clus), function(I) {
      xs <- X[I, , drop = FALSE]
      sum(stats::dist(xs)^d.power / nrow(xs))
    }, 0))
  }

  # Initialize the vectors
  logW <- E.logW <- SE.sim <- numeric(K.max)

  # Calculate logW
  for (k in 1:K.max) {
    logW[k] <- log(W.k(x, k))
  }

  # Prepare the data for bootstrapping
  spaceH0 <- match.arg(spaceH0)
  xs <- scale(x, center = TRUE, scale = FALSE)
  m.x <- rep(attr(xs, "scaled:center"), each = n)
  switch(spaceH0,
         scaledPCA = {
           V.sx <- svd(xs, nu = 0)$v
           xs <- xs %*% V.sx
         },
         original = {
         },
         stop("invalid 'spaceH0':", spaceH0))
  rng.x1 <- apply(xs, 2L, range)
  logWks <- matrix(0, B, K.max)
  logWks1 <- matrix(0, 1, K.max)

  # Perform the bootstrapping in parallel
  list.of.bootstraps <- 1:B
  if (nProc > 1 && !Sys.info()[["sysname"]] == "Windows") {
    BootGap <- parallel::mclapply(list.of.bootstraps, function(b) {
      z1 <- apply(rng.x1, 2, function(M, nn) stats::runif(nn, min = M[1], max = M[2]), nn = n)
      z <- switch(spaceH0, scaledPCA = tcrossprod(z1, V.sx), original = z1) + m.x
      for (k in 1:K.max) {
        logWks1[, k] <- log(W.k(z, k))
      }
      return(logWks1)
    }, mc.cores = nProc)
  } else {
    BootGap <- lapply(list.of.bootstraps, function(b) {
      z1 <- apply(rng.x1, 2, function(M, nn) stats::runif(nn, min = M[1], max = M[2]), nn = n)
      z <- switch(spaceH0, scaledPCA = tcrossprod(z1, V.sx), original = z1) + m.x
      for (k in 1:K.max) {
        logWks1[, k] <- log(W.k(z, k))
      }
      return(logWks1)
    })
  }

  # Combine the bootstrapping results
  logWks <- matrix(unlist(BootGap), ncol = K.max, nrow = B, byrow = TRUE)

  # Calculate the final results
  E.logW <- colMeans(logWks)
  SE.sim <- sqrt((1 + 1 / B) * apply(logWks, 2, stats::var))

  # Return the result
  structure(class = "clusGap", list(
    Tab = cbind(logW, E.logW, gap = E.logW - logW, SE.sim),
    call = cl., spaceH0 = spaceH0, n = n, B = B, FUNcluster = FUNcluster
  ))
}

# Function to plot a Gaussian mixture based on the model's parameter values
#' @importFrom AdaptGauss BayesDecisionBoundaries
#' @importFrom grDevices nclass.FD
#' @importFrom methods hasArg
#' @importFrom stats density na.omit
#' @importFrom DataVisualizations ParetoDensityEstimation
#' @importFrom rlang .data
#' @import ggplot2
#' @export
GMMplotGG <- function(Data, Means, SDs, Weights, BayesBoundaries, SingleGausses = TRUE,
                      Hist = FALSE, Bounds = TRUE, SumModes = TRUE, PDE = TRUE) {
  # Check input parameters
  if (!hasArg("Means") || !hasArg("SDs") || !hasArg("Weights")) {
    stop("GMMplotGG: Incomplete parameters.")
  }
  if (SingleGausses == FALSE && SumModes == FALSE) {
    stop("GMMplotGG: No model results requested to plot.\nUse other function to plot just raw data.")
  }
  if (length(c(Means, SDs, Weights)) %% 3 != 0) {
    stop("GMMplotGG: Unequal number of modes in parameters.")
  }

  # Prepare the data for plotting
  n <- 1000
  flag <- 0
  if (hasArg(Data)) {
    Data <- stats::na.omit(Data)
    if (length(Data) > 1) {
      if (PDE == TRUE) {
        PDF <- DataVisualizations::ParetoDensityEstimation(Data)
        x <- PDF$kernels
        PDF <- cbind.data.frame(Curve = "Data", x = PDF$kernels, y = PDF$paretoDensity)
      } else {
        PDF <- stats::density(Data)
        x <- PDF$x
        PDF <- cbind.data.frame(Curve = "Data", PDF$x, PDF$y)
      }
    } else {
      flag <- 1
    }
  } else {
    flag <- 1
  }
  if (flag == 1) {
    rangeX <- range(c(Means - 2 * SDs, Means + 2 * SDs))
    x <- seq(from = rangeX[1], to = rangeX[2], length.out = n)
    Hist <- FALSE
    PDE <- FALSE
  }

  # Prepare the Gaussian mixture data
  Means0 <- Means[order(Means)]
  SDs0 <- SDs[order(Means)]
  Weights0 <- Weights[order(Means)]

  DataDF <- data.frame(mapply(function(w, mean, sd) w * stats::dnorm(x, mean, sd), mean = Means0,
                              sd = SDs0, w = Weights0))
  ModeMaxima <- apply(DataDF, 2, max)
  ModeMaxima <- ModeMaxima + 0.015 * max(ModeMaxima)
  SumPDF <- cbind.data.frame(Curve = "Sum", x = x, y = rowSums(DataDF))
  DataDF_longSingle <- cbind.data.frame(Curve = rep(paste0("M", c(seq_along(Means0))),
                                                    each = length(x)), x = rep(x, length(Means0)),
                                        y = as.vector(as.matrix(DataDF)))

  # Combine the data frames for plotting
  if (PDE == TRUE && SumModes == TRUE) {
    DataDF_long <- rbind.data.frame(PDF, SumPDF)
  } else if (PDE == TRUE && SumModes == FALSE) {
    DataDF_long <- rbind.data.frame(PDF)
  } else if (PDE == FALSE && SumModes == TRUE) {
    DataDF_long <- rbind.data.frame(SumPDF)
  }
  if (SingleGausses == TRUE) {
    DataDF_long <- rbind.data.frame(DataDF_long, DataDF_longSingle)
  }

  # Create the plot
  requireNamespace("ggplot2")
  requireNamespace("grDevices")
  p1 <- ggplot()
  if (Hist == TRUE) {
    if (hasArg("Data") == TRUE && length(Data) > 1) {
      HistData <- Data
    } else {
      HistData <- SumPDF
    }
    breaks <- pretty(range(HistData), n = grDevices::nclass.FD(HistData), min.n = 1)
    bwidth <- breaks[2] - breaks[1]
    p1 <- p1 +
      geom_histogram(data = data.frame(HistData), aes(x = HistData, after_stat(density),
                                                      fill = "grey85"), binwidth = bwidth, color = "grey95") +
      guides(fill = "none") +
      scale_fill_manual(values = "grey85")
  }
  p1 <- p1 +
    geom_line(data = DataDF_long, aes(x = x, y = .data$y, colour = .data$Curve)) +
    labs(x = "Data", y = "Probability density")

  # Add Bayes decision boundaries if requested
  if (Bounds == TRUE && length(Means0) > 1) {
    flag <- 0
    if (hasArg(BayesBoundaries) == TRUE) {
      if (length(BayesBoundaries) == (length(Means) - 1)) {
        BayesBoundaries0 <- BayesBoundaries
      } else {
        flag <- 1
      }
    } else {
      flag <- 1
    }
    if (flag == 1) {
      BayesBoundaries0 <- AdaptGauss::BayesDecisionBoundaries(Means = Means0,
                                                              SDs = SDs0, Weights = Weights0)
    }
    BayesBoundariesDF <- data.frame(BayesBoundaries0)
    p1 <- p1 + geom_vline(data = BayesBoundariesDF, aes(xintercept = BayesBoundaries0),
                          color = "magenta", linetype = 2)
  }

  # Add mode labels if there are multiple modes
  if (length(Means0) > 1) {
    p1 <- p1 + annotate("text", x = Means0, y = ModeMaxima, size = rel(4), label = paste0("M#",
                                                                                          seq_along(Means0)))
  }

  return(p1)
}

# Function to create a probability matrix based on multimodal Gaussian
# distribution
#' @importFrom methods hasArg
#' @importFrom stats dnorm
#' @importFrom caTools sample.split
#' @importFrom dplyr sample_n
CreateGMM <- function(Means, SDs, Weights, n = 1000, ExactN = FALSE) {
  # Check if all required parameters are provided
  if (!hasArg("Means") || !hasArg("SDs") || !hasArg("Weights")) {
    stop("CreateGMM: Incomplete parameters.")
  }

  # Check if the number of parameters is divisible by 3
  if (length(c(Means, SDs, Weights)) %% 3 != 0) {
    stop("CreateGMM: Unequal number of modes in parameters.")
  }

  # Normalize the weights if necessary
  sumWeights <- sum(Weights)
  if (sumWeights != 1) {
    Weights <- Weights / sumWeights
  }

  # Determine the number of samples per mode
  if (ExactN == TRUE) {
    GMMparam <- rbind(round(Weights * 2 * n), Means, SDs)
  } else {
    GMMparam <- rbind(round(Weights * n), Means, SDs)
  }

  # Generate the data
  GMMparamRO <- split(GMMparam, rep(seq_len(ncol(GMMparam)), each = nrow(GMMparam)))
  DataDF <- cbind.data.frame(
    Data = as.vector(unlist(lapply(GMMparamRO, function(x) {
      do.call(stats::rnorm, as.list(x))
    }))),
    Cls = rep(seq_along(Weights), unlist(lapply(GMMparamRO, "[[", 1)))
  )

  # Ensure the exact number of samples if requested
  if (ExactN == TRUE) {
    sample <- caTools::sample.split(DataDF$Cls, SplitRatio = 0.51)
    DataDF <- dplyr::sample_n(subset(DataDF, sample == TRUE), 1000)
  }

  return(DataDF)
}

# Analysis of a Gaussian mixture structure in one-dimensional numerical data.
# Statistical justification with likelihood ratio and other tests.
#' @useDynLib opGMMassessment, .registration = TRUE
#' @importFrom ClusterR GMM
#' @importFrom mclust densityMclust
#' @importFrom mixtools normalmixEM
#' @importFrom parallel detectCores
#' @importFrom methods hasArg
#' @importFrom utils head tail sessionInfo
#' @importFrom stats ks.test rnorm sd
#' @importFrom DistributionOptimization DistributionOptimization
#' @importFrom mixAK NMixMCMC
#' @importFrom foreach foreach
#' @importFrom doParallel registerDoParallel stopImplicitCluster
#' @export
opGMMassessment <- function(Data, FitAlg = "MCMC", Criterion = "LR", MaxModes = 8,
                            MaxCores = getOption("mc.cores", 2L), PlotIt = FALSE, KS = TRUE, Seed) {

  # Check data input
  DIM <- function(...) {
    args <- list(...)
    unlist(lapply(args, function(x) {
      if (is.null(dim(x))) {
        return(1)
      }
      dim(x)[2]
    }))
  }

  if (missing(Data)) stop("opGMMassessment: No data provided. Stopping.")
  if (length(Data) == 0) stop("opGMMassessment: Data is empty.")
  if (DIM(Data) != 1 || is.numeric(Data) == FALSE) {
    stop("opGMMassessment: Data must be a one-dimensional numerical vector.")
  }
  if (length(Data) < 2) {
    stop("opGMMassessment: Too few data.")
  }
  if (is.factor(Data)) Data <- as.character(Data)
  if (is.numeric(Data)) {
    Data <- as.numeric(Data)
  } else if (is.integer(Data)) {
    Data <- as.numeric(Data)
  } else if (is.character(Data) || is.factor(Data)) {
    x <- as.character(Data)
    ok <- !is.na(suppressWarnings(as.numeric(x))) | is.na(x)
    if (!all(ok)) stop("opGMMassessment: Data must be numeric or coercible to numeric.")
    Data <- as.numeric(x)
  } else {
    stop("opGMMassessment: Data must be numeric or coercible to numeric.")
  }
  if (all(is.na(Data))) stop("opGMMassessment: Data contains only NA values.")

  # Check other input
  list.of.FitAlgs <- c("ClusterRGMM", "densityMclust", "DO", "MCMC", "normalmixEM")
  if (!FitAlg %in% list.of.FitAlgs) {
    stop("opGMMassessment: Fit algorithm not implemented. Use ClusterRGMM, DO, densityMclust or normalmixEM")
  }
  list.of.Criteria <- c("AIC", "BIC", "FM", "GAP", "LR", "NbClust", "SI")
  if (!Criterion %in% list.of.Criteria) {
    stop("opGMMassessment: Criterion not implemented. Use AIC, BIC, FM, GAP, LR, NbClust, or SI.")
  }
  list.of.Criteria.directModenumber <- c("FM", "GAP", "NbClust", "SI")
  if (hasArg("MaxModes")) {
    if (MaxModes < 1) {
      MaxModes <- 8
      warning("opGMMassessment: MaxModes was < 1 and has been set to the default of 8.", call. = FALSE)
    }
  }

  # Create main variables
  DataOrigLength <- length(as.vector(Data))
  DataOrignoNA <- which(!is.na(Data) & !is.infinite(Data))
  Data <- as.vector(Data[DataOrignoNA])
  GMMdata <- Data
  list.of.Modes <- 1:MaxModes
  BestGMM <- 1
  Means <- as.vector(mean(GMMdata, na.rm = TRUE))
  SDs <- as.vector(sd(GMMdata, na.rm = TRUE))
  Weights <- 1
  Mixtures1 <- cbind(Means, SDs, Weights)
  MaxRetries <- 3

  # Internal control functions
  num_workers <- parallel::detectCores()
  nProc <- min(num_workers - 1, MaxCores)

  if (!missing(Seed)) {
    ActualSeed <- Seed
  } else {
    ActualSeed <- tail(get(".Random.seed", envir = globalenv()), 1)
  }

  # Perform the GMM fit and determine the best model
  if (var(GMMdata) > 0) {
    if (!Criterion %in% list.of.Criteria.directModenumber) {
      GMMfit <- if (nProc > 1 && MaxModes > 1) {
        switch(Sys.info()[["sysname"]],
               Windows = {
                 doParallel::registerDoParallel(nProc)
                 x <- integer()
                 foreach::foreach(x = list.of.Modes) %dopar% {
                   PerformGMMfit(GMMdata = GMMdata, FitAlg = FitAlg, Modes = list.of.Modes[x],
                                 Mixtures1 = Mixtures1, ActualSeed = ActualSeed, MaxRetries = MaxRetries)
                 }
               },
               parallel::mclapply(list.of.Modes, function(x) {
                 PerformGMMfit(GMMdata = GMMdata, FitAlg = FitAlg, Modes = list.of.Modes[x],
                               Mixtures1 = Mixtures1, ActualSeed = ActualSeed, MaxRetries = MaxRetries)
               }, mc.cores = nProc))
      } else {
        lapply(list.of.Modes, function(x) {
          PerformGMMfit(GMMdata = GMMdata, FitAlg = FitAlg, Modes = list.of.Modes[x],
                        Mixtures1 = Mixtures1, ActualSeed = ActualSeed, MaxRetries = MaxRetries)
        })
      }

      BestGMM <- DetermineBestGMM(GMMdata = GMMdata, GMMfit = GMMfit, Criterion = Criterion,
                                  ActualSeed = ActualSeed, MaxModes = MaxModes, nProc = nProc, BestGMM = BestGMM)

      Means <- as.vector(GMMfit[[BestGMM]]$Mixtures[, 1])
      SDs <- as.vector(GMMfit[[BestGMM]]$Mixtures[, 2])
      Weights <- as.vector(GMMfit[[BestGMM]]$Mixtures[, 3])
    } else {
      BestGMM <- DetermineBestGMM(GMMdata = GMMdata, GMMfit = NA, Criterion = Criterion,
                                  ActualSeed = ActualSeed, MaxModes = MaxModes, nProc = nProc, BestGMM = BestGMM)
      GMMfit <- PerformGMMfit(GMMdata = Data, FitAlg = FitAlg, Modes = BestGMM,
                              Mixtures1 = Mixtures1, ActualSeed = ActualSeed, MaxRetries = MaxRetries)

      Means <- as.vector(GMMfit$Mixtures[, 1])
      SDs <- as.vector(GMMfit$Mixtures[, 2])
      Weights <- as.vector(GMMfit$Mixtures[, 3])
    }
  }

  # Calculate Bayes boundaries
  is.integer0 <- function(x) {
    is.integer(x) && length(x) == 0L
  }

  Boundaries <- c()
  ClassesB <- rep(1, length(GMMdata))
  if (BestGMM > 1) {
    Boundaries <- AdaptGauss::BayesDecisionBoundaries(Means = Means, SDs = SDs, Weights = Weights)
    if (is.integer0(Boundaries) == FALSE) {
      Boundaries <- Boundaries
    }
    if (length(Boundaries) > 0) {
      ClassesB <- cutGMM(x = GMMdata, breaks = Boundaries)
    }
  }

  Classes <- rep(NA, DataOrigLength)
  Classes[DataOrignoNA] <- ClassesB

  # Perform Kolmogorov-Smirnov test
  if (KS == TRUE) {
    set.seed(ActualSeed)
    Pred <- CreateGMM(Means = Means, SDs = SDs, Weights = Weights, n = 1000)$Data
    KStest <- suppressWarnings(stats::ks.test(x = GMMdata, y = Pred))
  } else {
    KStest <- NA
  }

  # Prepare the plot
  p1 <- GMMplotGG(Data = GMMdata, Means = Means, SDs = SDs, Weights = Weights, Hist = TRUE)
  if (PlotIt == TRUE) {
    print(p1)
  }

  # Return the results
  return(list(Cls = Classes, Means = Means, SDs = SDs, Weights = Weights, Boundaries = Boundaries,
              Plot = p1, KS = KStest))
}

# Perform the GMM fit using the selected algorithm.
#' @importFrom ClusterR GMM
#' @importFrom mclust densityMclust
#' @importFrom mixtools normalmixEM
#' @importFrom utils head tail sessionInfo
#' @importFrom DistributionOptimization DistributionOptimization
#' @importFrom mixAK NMixMCMC
#' @importFrom methods is
PerformGMMfit <- function(FitAlg, GMMdata, Modes, Mixtures1, ActualSeed, MaxRetries) {
  set.seed(ActualSeed)

  # Perform the GMM fit based on the selected algorithm
  switch(FitAlg,
         ClusterRGMM = {
           GMMfit_Mode <- try(ClusterR::GMM(data = data.frame(GMMdata), gaussian_comps = Modes,
                                            dist_mode = "eucl_dist"), TRUE)
           if (!is(GMMfit_Mode, "try-error")) {
             Mixtures <- cbind(GMMfit_Mode$centroids, sqrt(GMMfit_Mode$covariance_matrices),
                               GMMfit_Mode$weights)
             if (Modes == 1) {
               Mixtures <- t(as.matrix(Mixtures[which.max(Mixtures[, 3]), ]))
               Mixtures[3] <- 1
             }
           } else {
             GMMfit_Mode <- vector(mode = "list", length = 9)
             Mixtures <- Mixtures1
           }
         },
         densityMclust = {
           GMMfit_Mode <- try(mclust::densityMclust(data = GMMdata, G = Modes), TRUE)
           if (!is(GMMfit_Mode, "try-error")) {
             res <- GMMfit_Mode$parameters
             Mixtures <- cbind(unname(res$mean), sqrt(unname(res$variance$sigmasq)),
                               unname(res$pro))
             if (Modes == 1) {
               Mixtures <- t(as.matrix(Mixtures[which.max(Mixtures[, 3]), ]))
               Mixtures[3] <- 1
             }
           } else {
             GMMfit_Mode <- vector(mode = "list", length = 9)
             Mixtures <- Mixtures1
           }
         },
         DO = {
           GMMfit_Mode <- try(DistributionOptimization::DistributionOptimization(Data = GMMdata,
                                                                                 Modes = Modes, Monitor = 0, CrossoverRate = 0.9, ErrorMethod = "chisquare",
                                                                                 Seed = ActualSeed), TRUE)
           if (!is(GMMfit_Mode, "try-error")) {
             Mixtures <- cbind(GMMfit_Mode$Means, GMMfit_Mode$SDs, GMMfit_Mode$Weights)
             if (Modes == 1) {
               Mixtures <- t(as.matrix(Mixtures[which.max(Mixtures[, 3]), ]))
               Mixtures[3] <- 1
             }
           } else {
             GMMfit_Mode <- vector(mode = "list", length = 9)
             Mixtures <- Mixtures1
           }
         },
         MCMC = {
           NewSeed <- ActualSeed + 1e+05
           FitError <- TRUE
           FitRetriesCount <- 0
           while (FitError == TRUE & FitRetriesCount < MaxRetries) {
             Prior <- list(priorK = "fixed", Kmax = Modes)
             nMCMC <- c(burn = 5000, keep = 10000, thin = 5, info = 1000)
             GMMfit_Mode <- try(mixAK::NMixMCMC(y0 = GMMdata, prior = Prior, nMCMC = nMCMC),
                                TRUE)
             if (!is(GMMfit_Mode, "try-error")) FitError <- FALSE
             FitRetriesCount <- FitRetriesCount + 1
             if (is(GMMfit_Mode, "try-error")) set.seed(NewSeed + FitRetriesCount)
           }
           if (!is(GMMfit_Mode, "try-error")) {
             MeansMCMC <- GMMfit_Mode[[1]]$poster.mean.mu * GMMfit_Mode[[1]]$scale$scale +
               GMMfit_Mode[[1]]$scale$shift
             SDsMCMC <- sqrt(GMMfit_Mode[[1]]$scale$scale^2 * as.numeric(GMMfit_Mode[[1]]$poster.mean.Sigma))
             WeightsMCMC <- GMMfit_Mode[[1]]$poster.mean.w[seq(0, (GMMfit_Mode[[1]]$nx_w -
                                                                     1) * GMMfit_Mode[[1]]$prior$Kmax, by = GMMfit_Mode[[1]]$prior$Kmax) +
                                                             c(1:Modes)]
             Mixtures <- cbind(MeansMCMC, SDsMCMC, WeightsMCMC)
             if (Modes == 1) {
               Mixtures <- t(as.matrix(Mixtures[which.max(Mixtures[, 3]), ]))
               Mixtures[3] <- 1
             }
           } else {
             GMMfit_Mode <- vector(mode = "list", length = 9)
             Mixtures <- Mixtures1
           }
           set.seed(ActualSeed)
         },
         normalmixEM = {
           NewSeed <- ActualSeed + 1e+05
           FitError <- TRUE
           FitRetriesCount <- 0
           while (FitError == TRUE & FitRetriesCount < MaxRetries) {
             GMMfit_Mode <- try(mixtools::normalmixEM(GMMdata, mu = kmeans(GMMdata,
                                                                           Modes)$centers, ECM = TRUE, maxrestarts = 1e+05), TRUE)
             if (!is(GMMfit_Mode, "try-error")) FitError <- FALSE
             FitRetriesCount <- FitRetriesCount + 1
             if (is(GMMfit_Mode, "try-error")) set.seed(NewSeed + FitRetriesCount)
           }
           if (!is(GMMfit_Mode, "try-error")) {
             Mixtures <- cbind(GMMfit_Mode$mu, GMMfit_Mode$sigma, GMMfit_Mode$lambda)
             if (Modes == 1) {
               Mixtures <- t(as.matrix(Mixtures[which.max(Mixtures[, 3]), ]))
               Mixtures[3] <- 1
             }
           } else {
             GMMfit_Mode <- vector(mode = "list", length = 9)
             Mixtures <- Mixtures1
           }
           set.seed(ActualSeed)
         })

  return(list(GMMfit_Mode = GMMfit_Mode, Mixtures = Mixtures))
}

# Functions for mode number determination methods Identify best fit based on
# selected criterion.
#' @importFrom mixtools normalmixEM
#' @importFrom NbClust NbClust
#' @importFrom AdaptGauss InformationCriteria4GMM LikelihoodRatio4Mixtures
#' @importFrom utils head tail sessionInfo
#' @importFrom stats ks.test rnorm sd
#' @importFrom cluster pam maxSE
#' @importFrom multimode modetest
DetermineBestGMM <- function(GMMdata, GMMfit, Criterion, ActualSeed, MaxModes, BestGMM,
                             nProc) {

  # Function to identify the best GMM based on AIC/BIC
  idBestGMM_AICBIC <- function(GMMdata, GMMfit, Criterion, ActualSeed) {
    AICBIC <- lapply(seq_along(GMMfit), function(x) {
      AICBICi <- AdaptGauss::InformationCriteria4GMM(Data = GMMdata, Means = as.matrix(GMMfit[[x]]$Mixtures)[, 1],
                                                     SDs = as.matrix(GMMfit[[x]]$Mixtures)[, 2], Weights = as.matrix(GMMfit[[x]]$Mixtures)[, 3])
      return(AICBICi)
    })
    AICBIC <- unlist(lapply(seq_along(GMMfit), function(x) {
      switch(Criterion, AIC = AICBIC[[x]]$AIC, BIC = AICBIC[[x]]$BIC)
    }))
    BestGMM <- which.min(AICBIC)
    return(BestGMM)
  }

  # Function to identify the best GMM based on Excess Mass (FM)
  idBestGMM_FM <- function(GMMdata, MaxModes, nProc) {
    list.of.Modes <- 1:(MaxModes - 1)
    ExcessMassi <- switch(Sys.info()[["sysname"]],
                          Windows = lapply(list.of.Modes, function(x) multimode::modetest(GMMdata, method = "FM", mod0 = x, B = 60)$p.value),
                          parallel::mclapply(list.of.Modes, function(x) multimode::modetest(GMMdata, method = "FM", mod0 = x, B = 60)$p.value, mc.cores = nProc))
    firstBestGMM <- 1
    for (i in 2:length(ExcessMassi)) {
      if (ExcessMassi[i] < 0.05) {
        firstBestGMM <- i
      } else {
        break
      }
    }
    BestGMM <- firstBestGMM
    return(BestGMM)
  }

  # Function to identify the best GMM based on Gap Statistic
  idBestGMM_GAP <- function(GMMdata, MaxModes, ActualSeed, nProc) {
    pam1 <- function(x, k) {
      list(cluster = cluster::pam(x, k = 3, metric = "euclidean", stand = FALSE, cluster.only = TRUE))
    }
    gsPam1 <- clusGapP(x = cbind(GMMdata, GMMdata), FUNcluster = pam1, K.max = MaxModes,
                       B = 60, spaceH0 = "original", nProc = nProc)
    BestGMM <- with(gsPam1, maxSE(Tab[, "gap"], Tab[, "SE.sim"], method = "globalSEmax"))
    return(BestGMM)
  }

  # Function to identify the best GMM based on Likelihood Ratio (LR)
  idBestGMM_LR <- function(GMMdata, GMMfit, ActualSeed) {
    LRi <- c(1, unlist(lapply(2:MaxModes, function(x) {
      AdaptGauss::LikelihoodRatio4Mixtures(Data = GMMdata, NullMixture = as.matrix(GMMfit[[x - 1]]$Mixtures),
                                           OneMixture = as.matrix(GMMfit[[x]]$Mixtures), PlotIt = FALSE)$Pvalue
    })))
    firstBestGMM <- 1
    for (i in 2:length(LRi)) {
      if (LRi[i] < 0.05) {
        firstBestGMM <- i
      } else {
        break
      }
    }
    BestGMM <- firstBestGMM
    return(BestGMM)
  }

  # Function to identify the best GMM based on NbClust
  idBestGMM_NbClust <- function(GMMdata, MaxModes) {
    NBres <- suppressWarnings(NbClust::NbClust(GMMdata, method = "kmeans", distance = "euclidean",
                                               max.nc = MaxModes), classes = "warning")
    BestGMM <- length(unique(NBres$Best.partition))
    return(BestGMM)
  }

  # Function to identify the best GMM based on Silverman's Test (SI)
  idBestGMM_SI <- function(GMMdata, MaxModes, nProc) {
    list.of.Modes <- 1:(MaxModes - 1)
    ExcessMassi <- switch(Sys.info()[["sysname"]],
                          Windows = lapply(list.of.Modes, function(x) multimode::modetest(GMMdata, method = "SI", mod0 = x, B = 60)$p.value),
                          parallel::mclapply(list.of.Modes, function(x) multimode::modetest(GMMdata, method = "SI", mod0 = x, B = 60)$p.value, mc.cores = nProc))
    firstBestGMM <- 1
    for (i in 2:length(ExcessMassi)) {
      if (ExcessMassi[i] < 0.05) {
        firstBestGMM <- i
      } else {
        break
      }
    }
    BestGMM <- firstBestGMM
    return(BestGMM)
  }

  # Determine the best GMM based on the selected criterion
  switch(Criterion,
         AIC = BestGMM <- idBestGMM_AICBIC(GMMdata = GMMdata, GMMfit = GMMfit, Criterion = Criterion,
                                           ActualSeed = ActualSeed),
         BIC = BestGMM <- idBestGMM_AICBIC(GMMdata = GMMdata, GMMfit = GMMfit, Criterion = Criterion,
                                           ActualSeed = ActualSeed),
         FM = BestGMM <- idBestGMM_FM(GMMdata = GMMdata, MaxModes = MaxModes, nProc = nProc),
         GAP = BestGMM <- idBestGMM_GAP(GMMdata = GMMdata, MaxModes = MaxModes, nProc = nProc,
                                        ActualSeed = ActualSeed),
         LR = BestGMM <- idBestGMM_LR(GMMdata = GMMdata, GMMfit = GMMfit, ActualSeed = ActualSeed),
         NbClust = BestGMM <- idBestGMM_NbClust(GMMdata = GMMdata, MaxModes = MaxModes),
         SI = BestGMM <- idBestGMM_SI(GMMdata = GMMdata, MaxModes = MaxModes, nProc = nProc),
         BestGMM = BestGMM)

  return(BestGMM)
}

# Cuts a vector into separate groups according to input breaks
cutGMM <- function( x, breaks, right = TRUE ) {

  DIM <- function( ... ) {
    args <- list( ... )
    unlist( lapply( args, function( x ) {
      if ( is.null( dim( x ) ) ) {
        return( 1 )
      }
      dim( x )[2]
    } ) )
  }

  if ( DIM( x ) != 1 |
    is.numeric( x ) == FALSE |
    length( x ) == 0 ) {
    stop( "CutGMM: x should be a single numerical vector of length > 0." )
  }

  if ( length( breaks ) > 0 ) {
    if ( hasArg( right ) == FALSE ) {
      right <- TRUE
    }
    breaks <- sort( breaks )
    if ( right == TRUE ) {
      if ( length( breaks ) > 1 ) {
        compMat <- vapply( x, function( x ) x > breaks, logical( length( breaks ) ) )
        ClassesGMM <- colSums( compMat ) + 1
      } else {
        ClassesGMM <- as.numeric( x > breaks ) + 1
      }
    } else {
      if ( length( breaks ) > 1 ) {
        compMat <- vapply( x, function( x ) x >= breaks, logical( length( breaks ) ) )
        ClassesGMM <- colSums( compMat ) + 1
      } else {
        ClassesGMM <- as.numeric( x >= breaks ) + 1
      }
    }
  } else {
    warning( "cutGMM: No breaks provided. Assuming one single class.", call. = FALSE )
  }

  return( ClassesGMM )
}

\name{GMMplotGG}
\alias{GMMplotGG}
\title{Plot of Gaussian mixtures}
\description{
  The function plots the components of a Gaussian mixture and superimposes them on a histogram of the data.
}
\usage{
GMMplotGG(Data, Means, SDs, Weights, BayesBoundaries, 
	SingleGausses = TRUE, Hist = FALSE, Bounds = TRUE, SumModes = TRUE, PDE = TRUE)
}
\arguments{
 \item{Data}{the data as a vector.}
 \item{Means}{a list of mean values for a Gaussian mixture.}
 \item{SDs}{a list of standard deviations for a Gaussian mixture.}
 \item{Weights}{a list of weights for a Gaussian mixture.}
 \item{BayesBoundaries}{a list of Bayesian boundaries for a Gaussian mixture.}
 \item{SingleGausses}{whether to plot the single Gaussian components as separate lines.}
 \item{Hist}{whether to plot a histgram of the original data.}
 \item{Bounds}{whether to plot the Bayesian boundaries for a Gaussian mixture as vertical lines.}
 \item{SumModes}{whether to plot the summed-up mixes.}
 \item{PDE}{whether to use the Pareto density estimation instead of the standard R density function.}
}
\value{
  Returns a ggplot2 object.
 \item{p1}{the plot of Gaussian mixtures.}
 }
\references{
 Lotsch, J., Malkusch S. (2021):
 opGMMassessment -- an R Package for automated Guassian mixture modeling.
}
\author{
  Jorn Lotsch and Sebastian Malkusch
}
\examples{
## example 1
data(iris)
Means0 <- tapply(X = as.vector(iris[,3]), INDEX =  as.integer(iris$Species), FUN = mean)
SDs0 <- tapply(X = as.vector(iris[,3]), INDEX =  as.integer(iris$Species), FUN = sd)
Weights0 <- c(1/3, 1/3, 1/3)
GMM.Sepal.Length <- GMMplotGG(Data = as.vector(iris[3]), 
	Means = Means0, 
	SDs = SDs0, 
	Weights = Weights0, 
	Hist = TRUE) 
}
\keyword{GMMplotGG}
\keyword{data visualization}

\name{Chromatogram}
\alias{Chromatogram}

\docType{data}
\title{Example data of lysophosphatidic acids, LPA.}

\description{Data set containing times of detector hits after chromatographic separation of 
five different lysophosphatidic acids (Classes CLs = LPA 16:0, 18:0, 18:3, 20:0, and 20:4).}

\usage{data("Chromatogram")}

\details{
Size 1166 x 3 , stored in \code{Chromatogram$[Cls, Time, Lipids]}
}

\examples{
data(Chromatogram)
str(Chromatogram)
}

\name{Mixture3}
\alias{Mixture3}

\docType{data}
\title{Example Gaussian mixture data.}

\description{Data set containing 1000 instances distributed according to a Gaussian mixture with m = [-10, 0, 10], s = [1, 2, 3], w = [0.07, 0.05, 0.88].}

\usage{data("Mixture3")}

\details{
Size 1000 x 1
}

\examples{
data(Mixture3)
str(Mixture3)
}

\name{opGMMassessment}
\alias{opGMMassessment}
\title{Gaussian mixture assessment}
\description{
  The package provides the necessary functions for optimized automated evaluation of the number and parameters of Gaussian mixtures in one-dimensional data.
  It provides various methods for parameter estimation and for determining the number of modes in the mixture.
}
\usage{
opGMMassessment(Data, FitAlg = "MCMC", Criterion = "LR",
MaxModes = 8, MaxCores = getOption("mc.cores", 2L), PlotIt = FALSE, KS = TRUE, Seed)
}
\arguments{
 \item{Data}{the data as a numerical vector (1D).}
  \item{FitAlg}{which fit algorithm to use: "ClusterRGMM" = GMM from ClusterR,
  "densityMclust" from mclust,
  "DO" from DistributionOptimization (slow),
  "MCMC" = NMixMCMC from mixAK, or
  "normalmixEM" from mixtools.}
 \item{Criterion}{which criterion should be used to establish the number of modes from the best GMM fit:
 "AIC", "BIC", "FM", "GAP", "LR" (likelihood ratio test), "NbClust" (from NbClust), "SI" (Silverman).}
 \item{MaxModes}{the maximum number of modes to be tried.}
 \item{MaxCores}{the maximum number of processor cores used under Unix.}
 \item{PlotIt}{whether to plot the fit directly (plot will be stored nevertheless).}
 \item{KS}{perform a Kolmogorow-Smirnow test of the fit versus original distribution.}
 \item{Seed}{optional seed parameter set internally.}
}
\value{
  Returns a list of Gaussian modes.
 \item{Cls}{the classes to which the cases are assigned according to the Gaussian mode membership.}
 \item{Means}{means of the Gaussian modes.}
 \item{SDs}{standard deviations of the Gaussian modes.}
 \item{Weights}{weights of the Gaussian modes.}
 \item{Boundaries}{Bayesian boundaries between the Gaussian modes.}
 \item{Plot}{Plot of the obtained mixture.}
 \item{KS}{Results of the Kolmogorov-Smirnov test.}
 }
\references{
 Lotsch J, Malkusch S, Ultsch A. Comparative assessment of automated algorithms for the separation of one-dimensional Gaussian mixtures.
Informatics in Medicine Unlocked,  Volume 34, 2022, https://doi.org/10.1016/j.imu.2022.101113.
(https://www.sciencedirect.com/science/article/pii/S2352914822002507)
}
\author{
  Jorn Lotsch and Sebastian Malkusch
}
\examples{
## example 1
data(iris)
opGMMassessment(Data = iris$Petal.Length,
  FitAlg = "normalmixEM",
  Criterion = "BIC",
  PlotIt = TRUE,
  MaxModes = 5,
  MaxCores = 1,
  Seed = 42)
}
\keyword{opGMMassessment}
\keyword{Clustering}
